
void reset_port(void);
void id_command(void);	// issues the JTAG command to read the device ID for all 3 chips

void test_logic_reset(void);
void tap_submit_instr(int arg_command);
void flash_write_val_hold(long addr, long val);
void flash_write_val(long addr, long val);
long flash_read_val(long addr);
void flash_write_cmd(unsigned cmd_addr, int cmd);
void flash_wait(long max_erase_time);
void set_vppen(void);
void clr_vppen(void);

#define bothbanks(w_) ((((w_)&0xFFFF) << 16)|((w_)&0xFFFF))

#define EXTEST 0x00
#define IDCODE 0x06
#define BYPASS 0x1f

#define SA1110_CHAIN_LENGTH 292

#define	ROM_SEL_IN	0
#define	nRESET_OUT_OUT	1
#define	nRESET_IN	2
#define	TXD_3_IN	3
#define	TXD_3_OUT	4
#define	TXD_3_EN	5
#define	RXD_3_IN	6
#define	RXD_3_OUT	7
#define	RXD_3_EN	8
#define	TXD_2_IN	9
#define	TXD_2_OUT	10
#define	TXD_2_EN	11
#define	RXD_2_IN	12
#define	RXD_2_OUT	13
#define	RXD_2_EN	14
#define	TXD_1_IN	15
#define	TXD_1_OUT	16
#define	TXD_1_EN	17
#define	RXD_1_IN	18
#define	RXD_1_OUT	19
#define	RXD_1_EN	20
#define	UDCp_IN	21
#define	UDCp_OUT	22
#define	UDCp_EN	23
#define	UDCmUDCp_IN	24
#define	UDCm_IN	25
#define	UDCm_OUT	26
#define	UDCm_EN	27
#define	A0_OUT	28
#define	A1_OUT	29
#define	A2_OUT	30
#define	A3_OUT	31
#define	A4_OUT	32
#define	A5_OUT	33
#define	A6_OUT	34
#define	A7_OUT	35
#define	A8_OUT	36
#define	A9_OUT	37
#define	A10_OUT	38
#define	A11_OUT	39
#define	A12_OUT	40
#define	A13_OUT	41
#define	A14_OUT	42
#define	A15_OUT	43
#define	A16_OUT	44
#define	A17_OUT	45
#define	A18_OUT	46
#define	A19_OUT	47
#define	A20_OUT	48
#define	A21_OUT	49
#define	A22_OUT	50
#define	A23_OUT	51
#define	A24_OUT	52
#define	A25_OUT	53
#define	nCS0_OUT	54
#define	nCS1_OUT	55
#define	nCS2_OUT	56
#define	nCS3_OUT	57
#define	nCS4_OUT	58
#define	nCS5_OUT	59
#define	RDY_IN	60
#define	RD_nWR_OUT	61
#define	nCAS0_OUT	62
#define	nCAS1_OUT	63
#define	nCAS2_OUT	64
#define	nCAS3_OUT	65
#define	nRAS0_OUT	66
#define	nRAS1_OUT	67
#define	nRAS2_OUT	68
#define	nRAS3_OUT	69
#define	nSDCAS_OUT	70
#define	nSDRAS_OUT	71
#define	nOE_OUT	72
#define	nWE_OUT	73
#define	multiEN_EN	74
#define	nPCE1_OUT	75
#define	nPCE2_OUT	76
#define	nPREG_OUT	77
#define	nPWAIT_IN	78
#define	nIOIS16_IN	79
#define	PSKTSEL_OUT	80
#define	nPIOW_OUT	81
#define	nPIOR_OUT	82
#define	nPWE_OUT	83
#define	nPOE_OUT	84
#define	L_FCLK_IN	85
#define	L_FCLK_OUT	86
#define	L_FCLK_EN	87
#define	L_LCLK_IN	88
#define	L_LCLK_OUT	89
#define	L_LCLK_EN	90
#define	L_DD7_IN	91
#define	L_DD7_OUT	92
#define	L_DD7_EN	93
#define	L_DD6_IN	94
#define	L_DD6_OUT	95
#define	L_DD6_EN	96
#define	L_DD5_IN	97
#define	L_DD5_OUT	98
#define	L_DD5_EN	99
#define	L_DD4_IN	100
#define	L_DD4_OUT	101
#define	L_DD4_EN	102
#define	L_DD3_IN	103
#define	L_DD3_OUT	104
#define	L_DD3_EN	105
#define	L_DD2_IN	106
#define	L_DD2_OUT	107
#define	L_DD2_EN	108
#define	L_DD1_IN	109
#define	L_DD1_OUT	110
#define	L_DD1_EN	111
#define	L_DD0_IN	112
#define	L_DD0_OUT	113
#define	L_DD0_EN	114
#define	L_PCLK_IN	115
#define	L_PCLK_OUT	116
#define	L_PCLK_EN	117
#define	L_BIAS_IN	118
#define	L_BIAS_OUT	119
#define	L_BIAS_EN	120
#define	GP0_IN	121
#define	GP0_OUT	122
#define	GP0_EN	123
#define	GP1_IN	124
#define	GP1_OUT	125
#define	GP1_EN	126
#define	GP2_IN	127
#define	GP2_OUT	128
#define	GP2_EN	129
#define	GP3_IN	130
#define	GP3_OUT	131
#define	GP3_EN	132
#define	GP4_IN	133
#define	GP4_OUT	134
#define	GP4_EN	135
#define	GP5_IN	136
#define	GP5_OUT	137
#define	GP5_EN	138
#define	GP6_IN	139
#define	GP6_OUT	140
#define	GP6_EN	141
#define	GP7_IN	142
#define	GP7_OUT	143
#define	GP7_EN	144
#define	GP8_IN	145
#define	GP8_OUT	146
#define	GP8_EN	147
#define	GP9_IN	148
#define	GP9_OUT	149
#define	GP9_EN	150
#define	GP10_IN	151
#define	GP10_OUT	152
#define	GP10_EN	153
#define	GP11_IN	154
#define	GP11_OUT	155
#define	GP11_EN	156
#define	GP12_IN	157
#define	GP12_OUT	158
#define	GP12_EN	159
#define	GP13_IN	160
#define	GP13_OUT	161
#define	GP13_EN	162
#define	GP14_IN	163
#define	GP14_OUT	164
#define	GP14_EN	165
#define	GP15_IN	166
#define	GP15_OUT	167
#define	GP15_EN	168
#define	GP16_IN	169
#define	GP16_OUT	170
#define	GP16_EN	171
#define	GP17_IN	172
#define	GP17_OUT	173
#define	GP17_EN	174
#define	GP18_IN	175
#define	GP18_OUT	176
#define	GP18_EN	177
#define	GP19_IN	178
#define	GP19_OUT	179
#define	GP19_EN	180
#define	GP20_IN	181
#define	GP20_OUT	182
#define	GP20_EN	183
#define	GP21_IN	184
#define	GP21_OUT	185
#define	GP21_EN	186
#define	GP22_IN	187
#define	GP22_OUT	188
#define	GP22_EN	189
#define	GP23_IN	190
#define	GP23_OUT	191
#define	GP23_EN	192
#define	GP24_IN	193
#define	GP24_OUT	194
#define	GP24_EN	195
#define	GP25_IN	196
#define	GP25_OUT	197
#define	GP25_EN	198
#define	GP26_IN	199
#define	GP26_OUT	200
#define	GP26_EN	201
#define	GP27_IN	202
#define	GP27_OUT	203
#define	GP27_EN	204
#define	SMROM_EN_IN	205
#define	SDCKE0_OUT	206
#define	SDCLK0_OUT	207
#define	SDCLK1_OUT	208
#define	SDCLK1_EN	209
#define	SDCKE1_OUT	210
#define	SDCLK2_OUT	211
#define	D31_0_EN	212
#define	D31_IN	213
#define	D31_OUT	214
#define	D23_IN	215
#define	D23_OUT	216
#define	D15_IN	217
#define	D15_OUT	218
#define	D7_IN	219
#define	D7_OUT	220
#define	D30_IN	221
#define	D30_OUT	222
#define	D22_IN	223
#define	D22_OUT	224
#define	D14_IN	225
#define	D14_OUT	226
#define	D6_IN	227
#define	D6_OUT	228
#define	D29_IN	229
#define	D29_OUT	230
#define	D21_IN	231
#define	D21_OUT	232
#define	D13_IN	233
#define	D13_OUT	234
#define	D5_IN	235
#define	D5_OUT	236
#define	D28_IN	237
#define	D28_OUT	238
#define	D20_IN	239
#define	D20_OUT	240
#define	D12_IN	241
#define	D12_OUT	242
#define	D4_IN	243
#define	D4_OUT	244
#define	D27_IN	245
#define	D27_OUT	246
#define	D19_IN	247
#define	D19_OUT	248
#define	D11_IN	249
#define	D11_OUT	250
#define	D3_IN	251
#define	D3_OUT	252
#define	D26_IN	253
#define	D26_OUT	254
#define	D18_IN	255
#define	D18_OUT	256
#define	D10_IN	257
#define	D10_OUT	258
#define	D2_IN	259
#define	D2_OUT	260
#define	D25_IN	261
#define	D25_OUT	262
#define	D17_IN	263
#define	D17_OUT	264
#define	D9_IN	265
#define	D9_OUT	266
#define	D1_IN	267
#define	D1_OUT	268
#define	D24_IN	269
#define	D24_OUT	270
#define	D16_IN	271
#define	D16_OUT	272
#define	D8_IN	273
#define	D8_OUT	274
#define	D0_IN	275
#define	D0_OUT	276
#define	TXD_C_IN	277
#define	TXD_C_OUT	278
#define	TXD_C_EN	279
#define	RXD_C_IN	280
#define	RXD_C_OUT	281
#define	RXD_C_EN	282
#define	SCLK_C_IN	283
#define	SCLK_C_OUT	284
#define	SCLK_C_EN	285
#define	SFRM_C_IN	286
#define	SFRM_C_OUT	287
#define	SFRM_C_EN	288
#define	PWR_EN_OUT	289
#define	VDD_FAULT_IN	290
#define	BATT_FAULT_IN	291

